/* *******************************************************************************************
The MIT License

Copyright (c) 2007 Steven G. Greenberg

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to use, copy, modify, merge,
publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons
to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
DEALINGS IN THE SOFTWARE.
******************************************************************************************* */

#pragma once

#include "FileCache2.h"

class CAsfStream;


class CAsfFile
{
public:
	CAsfFile();

public:
	~CAsfFile(void);

protected:
	// Data - per file, not per stream

	// caller specifies open file handle in constructor. Caller is responsible for closing it, too.
	HANDLE	m_hInputFile;		// save copy of file handle here
	HANDLE	m_hOutputFile;
	BYTE*	m_pAsfHdrBuf;		// we'll read in the whole ASF header at once into here
	DWORD	m_pAsfHdrBufLen;	// length of the ASF header in above
	DWORD	m_dwPacketSize;


	CAsfStream*		m_pStream[MAX_WMV_STREAMS];

public:
	BOOL				ProcessHeader(void);
	void				SetCacheObject(CFileCache2* pAsfFile);
	inline void			SetInputHandle(HANDLE hIn) { m_hInputFile = hIn; }
	CAsfStream*			GetStreamObject(DWORD dwStreamIdxToWorkWith);	// change this name
	DWORD				IndexOfMajorVidStream(void);

protected:

	CFileCache2*	m_pInputFileCache;

	CAsfStream* GetOrCreateAsfStream(DWORD dwStreamNum);	// change this name

	BOOL		ProcSomeStreamPropObj(struct STREAM_PROPERTIES_OBJECT* pStreamPropObj, BOOL bExtraIndent);
	BOOL		ProcSomeExtStreamPropObject(struct EXTENDED_STREAM_PROPERTIES_OBJECT* pExtStreamObj);
	DWORD		ProcSomeMetaDataDescripRec(struct ASF_METADATA_DESCRIPTION_RECORD* pMetaDescripRec, DWORD dwBytesLeft);

	DWORD		ProcFilePropObj(struct FILE_PROPERTIES_OBJECT* pFilePropObj);

	BOOL		ProcASF_Header_Extension_Object(struct ASF_HEADER_EXTENSION_OBJECT* pExtHdrObj);

	BOOL		ProcASF_Metadata_Object(struct METADATA_OBJECT* pMetadata);
};
